/////////////////////////////////
/////Stat meters - Jotdaniel/////
/////////////////////////////////
//These are working stat meters for hud and
//stat panel.  This was inspired by Volte,
//and a few parts of the code are by Spuzzum
//(they were so good I just couldnt find a
//better way to do it)and those parts still have
//his original commenting.  I learned how to do
//this from going through Spuzzums meter snippet
//this is more of a compilation of what I have
//learned.  Most all of the code, and all of
//the icons are made by me, but I would like so
//very much to give the credit to Spuzzum and Volte
//for inspiring me to put this together, and for
//ideas and the mechanics of how a meter update should
//work.  I would charge a small fee for this, but
//I don't beleive its right to charge for it when
//the idea wasnt really mine to begin with.
//If you have any questions, find any bugs
//want to comment on a better way to do something
//or even just to say hi to me, e-mail me at
// jotdanieldbz@hotmail.com(note: I would change my e-mail
//address but I dont want to reroute all my e-mail.)
//I hope this will help some of you.

mob

	var
		HP = 10 //health
		MHP = 10 //max health
		MP = 10  //mana
		MMP = 10 // max mana
		obj/meter/health_meter  // variable for the stat panel health meter
		obj/mmeter/mana_meter   // variable for the stat panel mana meter

	New()
		..()
		src.health_meter = new // create a new health/mana_meter when a mob is created
		src.mana_meter = new

	Stat()
		statpanel("Character")
		stat("Health",src.health_meter)
		stat("Mana",src.mana_meter)
		stat(usr.contents)
		src.Update(src) // This calls the update proc to change icon states on the HUD meters
		src.health_meter.num = (src.HP/src.MHP)*src.health_meter.width // this sets percentage, which you get your frame number from
		src.mana_meter.num = (src.MP/src.MMP)*src.mana_meter.width
		src.health_meter.Update() // run the update proc on the stat panel meters to make them reflect your current health/mana
		src.mana_meter.Update()
		src.health_meter.name = "[src.HP]/[src.MHP]" // this shows the max and current hp/mana after the stat panel meter
		src.mana_meter.name = "[src.MP]/[src.MMP]"

obj

	var/num = 0 // current unrounded icon_state number
	var/width // number of frames in your meter, if you have frames 0 = 30 then this is set to 30
	          // even though theres 31 frames.

	meter // this is the stat panel health meter
		icon = 'smallhglobe.dmi'
		icon_state = "0"
		name = ""
		width = 11

	mmeter // this is the stat panel mana meter
		icon = 'smallmglobe.dmi'
		icon_state = "0"
		name = ""
		width = 11

	meter1 // hud health meter, more frames, larger, and much better detail
		icon = 'hpglobe.dmi'
		screen_loc = "1,1"
		icon_state = "0"
		layer = MOB_LAYER+10
		width = 16

	mmeter1 // hud mana meter
		icon = 'mpglobe.dmi'
		screen_loc = "2,1"
		icon_state = "0"
		layer = MOB_LAYER+10
		width = 16

	proc/Update()// NOTE: this is the only part of the code made by Spuzzum, I would change it but I see no point in doing this.
				 // NOTE: it also has the original commenting from Spuzzum.
		if(num < 0) //if the meter is negative
			num = 0 //set it to zero
		else if(num > width) //if the meter is over 100%
			num = width //set it to 100%
		src.icon_state = "[round(src.num)]" // this sets the icon state of the meter to its rounded off number

mob

	proc/Update(mob/M as mob)
		for(var/obj/meter1/N in M.client.screen)
			N.num = (src.HP/src.MHP)*N.width
			N.Update()
		for(var/obj/mmeter1/MM in M.client.screen)
			MM.num = (src.MP/src.MMP)*MM.width
			MM.Update()

	verb// These are just here as place holders, to show you how the meters will work when the stats change
		HP_MPrandom()
			HP = rand(1,10)
			MP = rand(1,10)
		HP_MPplus()
			HP += 1
			MP += 1
		HP_MPminus()
			HP -= 1
			MP -= 1
mob
	Login()
		..()
		src.client.screen += new/obj/meter1 // Add new objects to client.screen.
		src.client.screen += new/obj/mmeter1
